import React, { createContext, useContext, useMemo } from "react";
import { Appearance, Platform } from "react-native";
const DEFAULT_CONTEXT = {
    dark: Appearance.getColorScheme() === "dark",
    platform: Platform.OS,
};
const Context = createContext(DEFAULT_CONTEXT);
export const TailwindProvider = ({ dark, children }) => {
    // Memoize the context value to skip rerenders
    const value = useMemo(() => (Object.assign(Object.assign({}, DEFAULT_CONTEXT), { dark: Boolean(dark) })), [dark]);
    return React.createElement(Context.Provider, { value: value }, children);
};
export const useTailwind = () => {
    const ctx = useContext(Context);
    return ctx;
};
